/*----------------------------------------------------------------------------
 Copyright:      
 Author:         Radig Ulrich
 Remarks:        
 known Problems:
 Version:        
 Description:    
------------------------------------------------------------------------------*/

#include "hsv.h"

//############################################################################
//HSV to RGB 8Bit
//Farbkreis h = 0 bis 360 (Farbwert)
//          s = 0 bis 100 (Dunkelstufe)
//          v = 0 bis 100 (Farbsttigung)
//Rckgabewert r,g,b als Pointer
void hsv_to_rgb (uint16_t h,uint8_t s,uint8_t v, uint8_t* r, uint8_t* g, uint8_t* b)
{
	uint8_t diff;
	//Winkel im Farbkeis 0 - 360 in 1 Grad Schritten
	//h = (englisch hue) Farbwert
	//1 Grad Schrittweite, 4.25 Steigung pro Schritt bei 60 Grad
	if(h<61){
		*r = 255;
		*b = 0;
		*g = (425 * h) / 100;
		}else if(h < 121){
		*g = 255;
		*b = 0;
		*r = 255 - ((425 * (h-60))/100);
		}else if(h < 181){
		*r = 0;
		*g = 255;
		*b = (425 * (h-120))/100;
		}else if(h < 241){
		*r = 0;
		*b = 255;
		*g = 255 - ((425 * (h-180))/100);
		}else if(h < 301){
		*g = 0;
		*b = 255;
		*r = (425 * (h-240))/100;
		}else if(h< 361){
		*r = 255;
		*g = 0;
		*b = 255 - ((425 * (h-300))/100);
	}
	
	//Berechnung der Farbsttigung
	//s = (englisch saturation) Farbsttigung
	s = 100 - s; //Kehrwert berechnen
	diff = ((255 - *r) * s)/100;
	*r = *r + diff;
	diff = ((255 - *g) * s)/100;
	*g = *g + diff;
	diff = ((255 - *b) * s)/100;
	*b = *b + diff;
	
	//Berechnung der Dunkelstufe
	//v = (englisch value) Wert Dunkelstufe einfacher Dreisatz 0..100%
	*r = (*r * v)/100;
	*g = (*g * v)/100;
	*b = (*b * v)/100;
}