/*----------------------------------------------------------------------------
 Copyright:      
 Author:         Radig Ulrich
 Remarks:        
 known Problems: 
 Version:        
 Description:    
------------------------------------------------------------------------------*/

#ifndef _PROGRAMME_H
	#define _PROGRAMME_H
	
	#include <stdio.h>
	#include <stdlib.h>
	#include <avr/io.h>
	#include <util/delay.h>
	
	#include "hsv.h"
	
	void update_strip (void);
	void spi_put(uint8_t);
	void spi_init (void);
	void store_led_data (uint16_t, uint8_t, uint8_t, uint8_t);
	
	void fx_regenbogen (uint8_t s, uint8_t v);
	void fx_color (uint16_t h,uint8_t s, uint8_t v);
	void fx_rider (uint16_t h,uint8_t s, uint8_t v);
	void fx_run (uint16_t h,uint8_t s, uint8_t v);
	void fx_fire (void);
	
	#define MAX_LEDS 160 //  30LEDs/m * 5m
	
	#define SPI_DDR                 DDRB
	#define SPI_PORT                PORTB
	#define SPI_SCK                 5
	#define SPI_MOSI                3
	#define SPI_SS               	2
	
	typedef struct __attribute__ ((__packed__))
	{
		uint8_t                            r;                 
		uint8_t                            g;                        
		uint8_t                            b;                         
	} LED_DATA;
	
	LED_DATA led_data[MAX_LEDS];	
	
#endif //_UART_H